/***************************************************************************
                          measurementfile.cpp  -  description
                             -------------------
    begin                : Sun Apr 7 2002
    copyright            : (C) 2002 by Andreas Richter
    email                : ar5@rcs.urz.tu-dresden.de
 ***************************************************************************/


#include "measurementfile.h"

#include <qfile.h>
#include <qtextstream.h>

measurementFile::measurementFile(){
  //setFileName();
  datasetNr=0;
  locationsNr=0;
}
measurementFile::~measurementFile(){
}

int measurementFile::decodeLine(QString linetodecode, double array[10])
{
  bool lineend;
  bool success;
  QString valueStr;
  int valNr=0;
  int len;
  double val;
  int beginPos=0;
  lineend=false;
  while (success&&!lineend) {
    //beginPos+=(len+1);
    len=linetodecode.find(" ",beginPos)-beginPos;
    if (len>0) {
      //read next value
      valueStr=linetodecode.mid(beginPos,len);
      val=valueStr.toDouble(&success);
      if (success) {
        array[valNr]=val;
        valNr++;
      }
    }
    else {
      if (!(len+beginPos<linetodecode.length())) {
        // read last value
        len=linetodecode.length()-beginPos+1;
        valueStr=linetodecode.mid(beginPos,len);
        val=valueStr.toDouble(&success);
        if (success) {
          array[valNr]=val;
        }
        lineend=true;
      }
    }
    beginPos+=(len+1);
  }
  return valNr;
}

bool measurementFile::load()
{
  bool success;
  bool locationsRead=false;
  QString line;
  int lineNr=0;
  int k;
  QFile f(filename.path());
  success=f.open(IO_ReadOnly);
  if (success) {
    QTextStream t( &f );
    lineNr=0;
    while (!t.eof() && success ) {
      line = t.readLine();
      if (!locationsRead) {
        locationsNr=decodeLine(line,locations)+1;
        if (locationsNr>1) locationsRead=true;
      }
      else {
        if (decodeLine(line,data[lineNr])>0) {
          times[lineNr]=data[lineNr][0];
          for(k=1;k<=locationsNr;k++)
            data[lineNr][k-1]=data[lineNr][k];
          datasetNr=lineNr+1;
          lineNr++;
        }
      }
    }
    f.close();
    if (!locationsRead) success=false;
  }
  return success;
}

void measurementFile::setFileName(KURL name)
{
  filename = name;
}