/***************************************************************************
                          modeloutputcomparison.h  -  description
                             -------------------
    begin                : Mon Apr 8 2002
    copyright            : (C) 2002 by Andreas Richter
    email                : ar5@rcs.urz.tu-dresden.de
 ***************************************************************************/

#ifndef MODELOUTPUTCOMPARISON_H
#define MODELOUTPUTCOMPARISON_H


/**
  *@author Andreas Richter
  */

#include <kurl.h>

#include "measurementfile.h"

class modelOutputComparison {
public: 
	modelOutputComparison();
	~modelOutputComparison();
	
	double times[100];
	bool matchestimes[100];
	
	double locations[10];
	QString locationLabels[10];
	int matches[10];
	bool matchfound[10];	
	
	
	measurementFile *mData;
	
	int datasetNr;
	int locationsNr;
	
	bool mDataLoaded;	
	
	bool compare(KURL);
	bool plotAllCurves(KURL);
	bool plotObservedVsPredictedCurve(int, KURL);
	bool plotResidualsPlot(int, KURL);
	bool plotResidualsProbabilityPlot(int, KURL);
	bool plotResidualsHistogram(int,KURL);
	void setLocations(double[10],QString[10]);
	void setTimes(double[100]);
	void setData(int, int, double);
	void clearData();
	
private:

  double data[100][10];
  double measure[100];
  double calculated[100];
  double residuals[100][10];
  int residualsDistribution[10][10];
  double residualClasses[11][10];
  	
	double covariance[10];
	double B[10];
	
	double average(double d[100], int);
	double diffErrorSquares(double d1[100],double ,int);
	double getCovariance(double d1[100], double d2[100], int N);
	bool calculateResiduals();
	void calculateClasses();
	void calculateResidualDistribution();
	
};

#endif
