/***************************************************************************
                          modelparameters.h  -  description
                             -------------------
    begin                : Wed Apr 3 2002
    copyright            : (C) 2002 by Andreas Richter
    email                : ar5@rcs.urz.tu-dresden.de
 ***************************************************************************/

#ifndef MODELPARAMETERS_H
#define MODELPARAMETERS_H

/**
  *@author Andreas Richter
  */

class modelParameters {
public: 
	modelParameters();
	~modelParameters();
	
  double a0a;
  double a0r;
  double a11;
  double a12;
  double a2;
  double dt;
  double n;
  double iv;
  double c01;
  double c02;
  double a0ae;
  double a0re;
  double re;

  double d;
  double u0;
  double l;
  double r0;
  double c0;
  double k1;
  double k2;
  double vd;
  double dtstar;

  void calcU();
  void calcL();
  void calcD();
  void calcK1();
  void calcK2();
  void calcVd();
  void calcC0();
  void calcR0();
  void calcDeltaTstar();

  bool calculateDimensionalParameters();
  bool calculateDimensionlessParameters();

private:
  bool calculated;
  bool error;


};

#endif
