/***************************************************************************
                          myparameterentrydialog.cpp  -  description
                             -------------------
    begin                : Thu Mar 28 2002
    copyright            : (C) 2002 by Andreas Richter
    email                : ar5@rcs.urz.tu-dresden.de
 ***************************************************************************/

#include <qstring.h>

#include <klineedit.h>

#include "myparameterentrydialog.h"

myParameterEntryDialog::myParameterEntryDialog(QWidget* parent,  const char* name, bool modal, WFlags fl)
  :ParameterEntryDialog(parent, name, modal, fl ) {

  pa = new modelParameters();
}
myParameterEntryDialog::~myParameterEntryDialog(){
}

void myParameterEntryDialog::getParameters(double *params, int N,int flowType)
{
  w_a0a->setText(QString::number(params[3]));
  w_a0r->setText(QString::number(params[4]));
  w_a11->setText(QString::number(params[5]));
  w_a12->setText(QString::number(params[6]));
  w_a2->setText(QString::number(params[7]));
  w_deltat->setText(QString::number(params[1]));
  w_a0ae->setText(QString::number(params[8]));
  w_a0re->setText(QString::number(params[9]));
  w_re->setText(QString::number(params[10]));
  w_r0->setText(QString::number(params[11]));
  w_c01->setText(QString::number(params[12]));
  w_c02->setText(QString::number(params[13]));
  w_n->setText(QString::number((int)params[0]));
  w_cupmixiv->setText(QString::number((int)params[2]));
  if (flowType!=1) {
    w_a0ae->setEnabled(false);
    w_a0re->setEnabled(false);
    w_re->setEnabled(false);
  }
  if (exec()) {
    params[3]=w_a0a->text().toFloat();
    params[4]=w_a0r->text().toFloat();
    params[5]=w_a11->text().toFloat();
    params[6]=w_a12->text().toFloat();
    params[7]=w_a2->text().toFloat();
    params[1]=w_deltat->text().toFloat();
    params[8]=w_a0ae->text().toFloat();
    params[9]=w_a0re->text().toFloat();
    params[10]=w_re->text().toFloat();
    params[11]=w_r0->text().toFloat();
    params[12]=w_c01->text().toFloat();
    params[13]=w_c02->text().toFloat();
    params[0]=w_n->text().toFloat();
    params[2]=w_cupmixiv->text().toFloat();
  }
}

void myParameterEntryDialog::slotCalculateDimensionlessParameters()
{
  bool *ok;
	ok = new bool;
  pa->d = w_d->text().toDouble(ok);
  pa->k1 = w_k1->text().toDouble(ok);
  pa->k2 = w_k2->text().toDouble(ok);
  pa->vd = w_vd->text().toDouble(ok);
  pa->u0 = w_u->text().toDouble(ok);
  pa->l = w_l->text().toDouble(ok);
  pa->r0 = w_r0->text().toDouble(ok);
  pa->c0 = w_c0->text().toDouble(ok);
  pa->dtstar = w_deltat_star->text().toDouble(ok);
  if (!pa->calculateDimensionlessParameters())
    sorryBox->sorry(this,"U, L,r0 and D have to be known and nonzero!","Error!",true);
  else
  {
    w_a0a->setText(QString::number(pa->a0a));
    w_a0r->setText(QString::number(pa->a0r));
    w_a11->setText(QString::number(pa->a11));
    w_a12->setText(QString::number(pa->a12));
    w_a2->setText(QString::number(pa->a2));
    w_deltat->setText(QString::number(pa->dt));	
  }
}

void myParameterEntryDialog::slotCalculateDimensionalParameters()
{
  bool *ok;
	ok = new bool;	
	
  pa->a0a = w_a0a->text().toDouble(ok);
  pa->a0r = w_a0r->text().toDouble(ok);
  pa->a11 = w_a11->text().toDouble(ok);
  pa->a12 = w_a12->text().toDouble(ok);
  pa->a2 = w_a2->text().toDouble(ok);
  pa->dt = w_deltat->text().toDouble(ok);

  pa->r0 = w_r0->text().toDouble(ok);
  pa->c0 = w_c0->text().toDouble(ok);
  pa->l = w_l->text().toDouble(ok);
  pa->u0 = w_u->text().toDouble(ok);
  pa->d = w_d->text().toDouble(ok);
  pa->k1 = w_k1->text().toDouble(ok);
  pa->k2 = w_k2->text().toDouble(ok);
  pa->vd = w_vd->text().toDouble(ok);
  pa->dtstar = w_deltat_star->text().toDouble(ok);

  if (!pa->calculateDimensionalParameters()) {
    sorryBox->sorry(this,"Not enough information available to solve for all missing variables.\nPlease specify some more dimensional data.","Error!",true);
  } else {
    w_r0->setText(QString::number(pa->r0));
    w_c0->setText(QString::number(pa->c0));
    w_l->setText(QString::number(pa->l));
    w_u->setText(QString::number(pa->u0));
    w_d->setText(QString::number(pa->d));
    w_k1->setText(QString::number(pa->k1));
    w_k2->setText(QString::number(pa->k2));
    w_vd->setText(QString::number(pa->vd));
    w_deltat_star->setText(QString::number(pa->dtstar));
  }
}