/* -------------------------------------------------------------

   options.h (part of input)

   Copyright (C) 2000-2001 Andreas Richter <ar5@rcs.urz.tu-dresden.de>

   This file is distributed under the GPL.
   See LICENSE for details.

   -------------------------------------------------------------

   GlobalData      manages all global data of Input
   DialgoListBox   a list box which ignores Enter, usefull for dialogs
   OptionsDialog   the "Preferences" dialog

 ------------------------------------------------------------- */


#include <qlistbox.h>
#include <kdialogbase.h>
#include <kmessagebox.h>

class QLineEdit;
class QCheckBox;
class QComboBox;
class QRadioButton;

class KColorButton;
class KLineEdit;
class KIntSpinBox;


//********* GlobalData ******************************************

#define COL_CNT 6
#define FNT_CNT 2

class GlobalData
{

public:
  GlobalData();
  void read();
  void write();

   KURL solverPath;
   KURL initialConditionFileName;
   KURL outputFileName;
   KURL plotFileName;
   KURL cupmixingAverageFileName;
   KURL measurementDataFileName;
   KURL measurementPlotFileName;

   //
   KURL timeSeriesPlotFileName;

   QString plotOptions;
   // dimensionless parameters
   double a0a;
   double a0r;
   double a11;
   double a12;
   double a2;
   double a0ae;
   double a0re;
   double re;
   double c01;
   double c02;
   //
   double deltatstar;
   // dimensional parameters
   double d;
   double u;
   double l;
   double r0;
   double k1;
   double k2;
   double c0;
   double vd;
   //
   unsigned long int n;
   double cupmixiv;
   double deltat;
   //
   int averagetype;
   int flow;
	 bool velocity;
	 //
	 int variablesNr;
	 double multipleRunVariables[100][26];
	 int runsNumber;
	 //
	 double locations[10];
	 QString locationLabels[10];
	 int locationsNr;
	
   KMessageBox *sorryb;

   QWidget *topLevel;
	 bool essentialsAvailable;	

private:
  void checkEssentials();
};

extern GlobalData *global;


